> For the complete documentation index, see [llms.txt](https://docs.digit.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digit.org/public-finance/v2.3/exemplar/mgramseva/architecture.md).

# Architecture

mGramSeva is built on top of the [DIGIT ](https://docs.digit.org/)Platform. It consists of the following layers

1. [Front End](https://ifix.digit.org/exemplar/mgramseva/user-manual/mgramseva-ui)
2. Back End
   1. Core Services
      1. [User Service](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/user-service) (egov-user)
      2. [User OTP](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/mgramseva-user-otp) (user-otp)
      3. [Access Control](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/access-control-services) (access-control)
      4. [MDMS](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/mdms-services)
      5. [ID Generation Service](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/37060616/ID-Generation-Service) (id-gen)
      6. [Payment Gateway](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/payment-gateway-services) (pg-service)
      7. [Workflow Service ](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/workflow-services)(wf-service)
      8. [Persister](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/37322761/Persister-Service)
      9. [Indexer](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/indexer-service)
      10. [Encryption Service ](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/5832708/Encryption+Service)(data-encryption-service)
      11. [Localization Service ](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/336920792/eGov-Localisation)(localization-service)
      12. [Boundary Service](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/location-services) (location-service)
      13. [URL Shortening Service](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/url-shortening-service) (url-shortening-service)
      14. [PDG Generation Service](https://docs.digit.org/configuration/configure-digit/services-overview/core-services/pdf-generation-services) (pdf-generator)
      15. [SMS Notifications](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/224919569/egov-notification-sms) (notification-sms)
      16. notification-email
      17. [Filestore](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/37060620/File-Store-Service)
      18. [API Gateway](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/36700192/API-Gateway)
   2. Business Services
      1. [Billing Service](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/billing-service)
      2. [Collection service](https://docs.digit.org/configuration/configure-digit/services-overview/business-services/collection-service/collection-service-v2)
      3. [Apportioning Service](https://docs.digit.org/configuration/configure-digit/services-overview/business-services/appropriation-service)
      4. [Dashboard Ingest](https://docs.digit.org/configuration/configure-digit/services-overview/business-services/dss-technical-documentation)
      5. [Dashboard Analytics](https://docs.digit.org/configuration/configure-digit/services-overview/business-services/dashboard-analytics-backend) (DSS)
   3. Municipal services:
      1. [Property Service ](https://docs.digit.org/product/modules/property-tax/property-tax-service)(property-services)
      2. [Water Service Calculator](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/water-service-calculator) (ws-calculator)
      3. [Water Service](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/water-services) (ws-service)
      4. [eChallan](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/e-challan-service) (echallan)
      5. [User Events](https://digit-discuss.atlassian.net/wiki/spaces/EPE/pages/231407688/egov-user-events) (user-event)
      6. [Vendor](https://docs.digit.org/product/modules/faecal-sludge-management-fsm/fsm-service-configuration/fsm-vendor-registry-v1.0)
      7. [IFIX Adaptor Integration Service](https://ifix.digit.org/exemplar/mgramseva/user-manual/backend-services/ifix-adapter-integration-service)

![mGramSeva Architecture Diagram](/files/mFEHCFL4Fywkm5qdDeSp)

## Services Architecture

The sequence diagram below illustrates a typical interaction between the various services.

![Sample sequence diagram for a typical flow of digit Microservices](/files/-MjIjnn2orGB4euQEf7C)

> [![Creative Commons License](https://i.creativecommons.org/l/by/4.0/80x15.png)*​*](http://creativecommons.org/licenses/by/4.0/)*All content on this page by* [*eGov Foundation*](https://egov.org.in/) *is licensed under a* [*Creative Commons Attribution 4.0 International License*](http://creativecommons.org/licenses/by/4.0/)*.*


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.digit.org/public-finance/v2.3/exemplar/mgramseva/architecture.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
